//---------------------------------------------
function R=Rot(a,i);
    R=eye(4,4);
    J=modulo([i,i+1],3)+[1,1];
    R(J,J)=[cos(a) -sin(a);sin(a) cos(a)];  
endfunction
//---------------------------------------------
function T=Trans(v);
    T=eye(4,4);
    T(1:3,4)=v;  
endfunction
//---------------------------------------------
function draw(x)
   M=[0 1 1 0 0 0 1 1 0 0 0 0 1 1 1 1;
      0 0 0 0 0 1 1 1 1 1 1 0 0 1 1 0;
      0 0 1 1 0 0 0 1 1 0 1 1 1 1 0 0;
      1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1] ;
   M=Trans([0;-0.5;-0.5])*M;
   M1=diag([3,0.3,0.3,1])*M;
   M2=diag([2,0.3,0.3,1])*M;
   M3=diag([1,0.3,0.3,1])*M;
   R1=Rot(0.5,1)*Rot(x(1),3); 
   R2=Trans([3;0;0])*Rot(x(2),3); 
   R3=Trans([2;0;0])*Rot(x(3),1);
   M1=R1*M1;   
   M2=R1*R2*M2;  
   M3=R1*R2*R3*M3;    
   xbasc();xset('thickness',2);
   isoview(-4,4,-3,3)
   xpoly(M1(1,:),M1(3,:)); xpoly(M2(1,:),M2(3,:)); xpoly(M3(1,:),M3(3,:))
endfunction;
//---------------------------------------------
x=[0;1;0]; w=[3;-1;7]; dt=0.001;
for k=1:5000,
        x=x+dt*w;
        draw(x);
end;
//---------------------------------------------
