function draw_char(x,w,col)
	M =[  1 -1  0  0 -2 -2 0 0 -1 1 0 0 3  3  0; 
			 -2 -2 -2 -1 -1  1 1 2  2 2 2 1 1 -1 -1;
		    1  1  1  1  1  1 1 1  1 1 1 1 1  1  1];
	M =[cos(x(3)),-sin(x(3)),x(1);sin(x(3)),cos(x(3)),x(2);0 0 1]*M;
	xset('color',col);
	xpoly(M(1,:),M(2,:));
//	r=0.3;xarc(-r+w(1),r+w(2),2*r,2*r,0,0);
 	t1=0:0.1:6.29; xpoly(0.3*cos(t1)+w(1),0.3*sin(t1)+w(2));

endfunction;
//-------------------------
function v=f(x,u)
	v =[x(4)*cos(x(3));x(4)*sin(x(3));u(1);u(2)];
endfunction
//-------------------------
function u=regul(x,w,dw)
		A=[-x(4)*sin(x(3)) cos(x(3));  x(4)*cos(x(3)) sin(x(3))];
		y=[x(1);x(2)];
		dy=[x(4)*cos(x(3));x(4)*sin(x(3))];
		u = inv(A)*((w-y)+2*(dw-dy));
endfunction
//-------------------------
xa=[10;0;1;1]; xb=[0;0;1;2]; xc=[-10;0;1;3]; // a l'endroit
//xa=[10;0;1;-1]; xb=[0;0;1;-2]; xc=[-10;0;1;-3]; // a l'envers
dt=0.005; l=6; Lx=15;Ly=7;
rouge=5;bleu=2;blanc=8;vert=3;noir=0;magenta=6;jaune=4;
for t=0:dt:150   //0 0.4
   	wa = [ Lx*sin(0.1*t); Ly*cos(0.1*t)];
		dwa=[Lx*0.1*cos(0.1*t);-Ly*0.1*sin(0.1*t)];
		ua=regul(xa,wa,dwa);
		wb=[xa(1)-l*cos(xa(3));xa(2)-l*sin(xa(3))];
		dwb=[xa(4)*cos(xa(3))+l*ua(1)*sin(xa(3)); xa(4)*sin(xa(3))-l*ua(1)*cos(xa(3))];
	  ub=regul(xb,wb,dwb);
		wc=[xb(1)-l*cos(xb(3));xb(2)-l*sin(xb(3))];
		dwc= [xb(4)*cos(xb(3))+l*ub(1)*sin(xb(3));	xb(4)*sin(xb(3))-l*ub(1)*cos(xb(3))];
	  uc=regul(xc,wc,dwc);
   	xbasc();xset('thickness',1);isoview(-15,15,-10,10);
   	t1=0:0.01:6.29; xpoly(Lx*cos(t1),Ly*sin(t1));
   	xset('thickness',2);
	  draw_char(xa,wa,rouge);
	  draw_char(xb,wb,bleu);
	  draw_char(xc,wc,noir);
	  xa=xa+f(xa,ua)*dt;
	  xb=xb+f(xb,ub)*dt;
	  xc=xc+f(xc,uc)*dt;
end

