function my_eventhandler(win,x,y,ibut)   //(handler = baggagiste)
       global xd sortie ech;
       xinfo(' Rglage Zoom : z,Z; Fin : F;')
       if ascii(ibut)=='w' then xd=xd+2; end   
       if ascii(ibut)=='x' then xd=xd-2; end   
       if ascii(ibut)=='z' then ech=ech*0.95; end   
       if ascii(ibut)=='Z' then ech=ech/0.95; end   
       if ascii(ibut)=='F' then sortie=%T;    end   
endfunction
//------------------------------------------------------
function draw_segway(x)
    rouge=5;bleu=2;blanc=8;vert=3;noir=0;magenta=6;
    M=[0.3*l*[0 1 1.5 0 -1.5 -1 0; 0 1 6 6.3 6 1 0]; 1 1 1 1 1 1 1] ;
    a=-R*x(1);
    M=[cos(x(2)),-sin(x(2)),a;sin(x(2)),cos(x(2)),0;0 0 1]*M;
    xbasc();
    isoview(-ech,ech,-ech,ech)
    xset('color',noir);
    xset('thickness',2);
    xpoly(M(1,:),M(2,:));
    xset('color',magenta);
    for k=1:8,
      b=x(1)+k*%pi/4;
      Mrayon=[cos(b),-sin(b),a;sin(b),cos(b),0;0 0 1]*[-R R;0 0;1 1]
      xpoly(Mrayon(1,:),Mrayon(2,:));
    end
    xarc(a-R,R,2*R,2*R,0,0);
    xset('color',bleu);
    xarc(-R*xd-R,R,2*R,2*R,0,0);
endfunction;
//------------------------------------------------------
function v=f(x,u)
    c2=cos(x(2));s2=sin(x(2))
    den=mu1*mu2-(mu3*c2)^2;
    w2=x(4)^2;
    v=[x(3);
       x(4);
       (1/den)*(mu3*(mu2*w2-mug*c2)*s2+(mu2+mu3*c2)*u);
       (1/den)*((mu1*mug-mu3^2*w2*c2)*s2-(mu1+mu3*c2)*u); 	
        ];
endfunction;
//------------------------------------------------------

global xd sortie ech ;
xd=5;
sortie=%F;
ech=2;

m=10;M=1;l=1;g=10;u=0;R=0.3;Jp=10;JM=0.5*M*R^2;   
mu1=R^2*(m+M)+JM; mu2=Jp+m*l^2; mu3=m*R*l; mug=g*m*l;
dt=0.006;
x=[0;0;0;0];   //tat initial du segway
xr=[0;0;0;0];  //tat initial de l'observateur
A=[0 0 1 0;0 0 0 1;0 -mu3*mug/(mu1*mu2-mu3^2) 0 0;0 mu1*mug/(mu1*mu2-mu3^2) 0 0];
B=[0;0;(mu2+mu3)/(mu1*mu2-mu3^2);(-mu1-mu3)/(mu1*mu2-mu3^2)];
C=[1 0 0 0];
E=[1 0 0 0];
K=ppol(A,B,[-2,-2,-2,-2]);
L=ppol(A',C',[-2,-2,-2,-2])';
H=-inv(E*inv(A-B*K)*B);
Ar=A-B*K-L*C;
Br=[B*H L];
Cr=-K;
t=0;
seteventhandler('my_eventhandler');
while sortie==%F, 
     t=t+dt;
     w=xd;
     u=Cr*xr+H*w;
     y=C*x;
     x=x+f(x,u)*dt;
     //xr=xr+(Ar*xr+Br*[w;y])*dt;			//Observateur classique (moins stable)
     xr=xr+(f(xr,u)-L*(C*xr-y))*dt;     //Observateur tendu
     draw_segway(x);
end;
seteventhandler('') //suppress the event handler
xdel();


//------------------------------------------------------




