//------------------------------------------------------
function draw_segway(x)
    xset('color',0);
    M=[0.3*l*[0 1 1.5 0 -1.5 -1 0; 0 1 6 6.3 6 1 0]; 1 1 1 1 1 1 1] ;
    a=-R*x(1);
    M=[cos(x(2)),-sin(x(2)),a;sin(x(2)),cos(x(2)),0;0 0 1]*M;
    xbasc(); xset("pixmap",1);
    ech=2;
    xset('thickness',2);
    isoview(-ech,ech,-ech,ech);
    xpoly(M(1,:),M(2,:));
    for k=1:8,
      b=x(1)+k*%pi/4;
      Mrayon=[cos(b),-sin(b),a;sin(b),cos(b),0;0 0 1]*[-R R;0 0;1 1]
      xpoly(Mrayon(1,:),Mrayon(2,:));
    end
    xarc(a-R,R,2*R,2*R,0,0);
    xset("wshow");
endfunction;
//------------------------------------------------------
function v=f(x,u)
   c2=cos(x(2));s2=sin(x(2))
    den=mu1*mu2-(mu3*c2)^2;
    w2=x(4)^2;
    v=[x(3);
       x(4);
        (1/den)*(mu3*(mu2*w2-mug*c2)*s2+(mu2+mu3*c2)*u);
       (1/den)*((mu1*mug-mu3^2*w2*c2)*s2-(mu1+mu3*c2)*u); 	
        ];
endfunction;
//------------------------------------------------------
m=10;M=1;l=1;g=10;u=0;R=0.3;Jp=10;JM=0.5*M*R^2;   
mu1=R^2*(m+M)+JM; mu2=Jp+m*l^2; mu3=m*R*l; mug=g*m*l;
dt=0.0015;
x=[0;0.1;-0.2;1];  
for t=0:dt:2,
     draw_segway(x);
     x=x+f(x,u)*dt;
end;
//------------------------------------------------------
