function my_eventhandler(win,x,y,ibut)   //(handler = baggagiste)
			  global r0 v0 sortie ech I x;
       xinfo(' Rglage Zoom : z,Z; Rayon : R,r; Vitesse : V,V, Effet Intgral : i; Fin : F;')
       if ascii(ibut)=='N' then x=[40*rand(1);40*rand();3*rand();3;0]; end   
       if ascii(ibut)=='R' then r0=r0+5; end   
       if ascii(ibut)=='r' then r0=r0-5; end   
       if ascii(ibut)=='V' then v0=v0+15; end   
       if ascii(ibut)=='v' then v0=v0-15; end   
       if ascii(ibut)=='z' then ech=ech*0.95; end   
       if ascii(ibut)=='Z' then ech=ech/0.95; end   
       if ascii(ibut)=='F' then sortie=%T;    end   
       if ascii(ibut)=='i' then I=1-I;    end   
endfunction

//------------------------------------------------------
function draw_voiture(x)
   M=[-1  4 5  5 4 -1 -1   -1 0  0  -1  1  0 0 -1 1 0 0 3 3 3;  //Chassis
      -2 -2 -1 1 2 2  -2   -2 -2 -3 -3 -3 -3 3  3 3 3 2 2 3 -3;
      ones(1:21)] ;
   Rav=[-1 1;0 0;1 1];  //Motif d'une roue avant
   R=[cos(x(3)),-sin(x(3)),x(1);sin(x(3)),cos(x(3)),x(2);0 0 1];
   M=R*M;    
   Ravd=R*[cos(x(5)),-sin(x(5)) 3;sin(x(5)),cos(x(5))  3;0 0 1]*Rav;
   Ravg=R*[cos(x(5)),-sin(x(5)) 3;sin(x(5)),cos(x(5)) -3;0 0 1]*Rav;
   rouge=5;bleu=2;blanc=8;vert=3;noir=0;magenta=6;
   xset('font',2,3);
   xbasc();
   isoview(-ech,ech,-ech,ech)
   xset('color',magenta);
   xset('thickness',2);
   r1=c(1);xarc(-r1,r1,2*r1,2*r1,0,0);
   xset('color',noir);
   xpoly(M(1,:),M(2,:));
   xpoly(Ravd(1,:),Ravd(2,:))
   xpoly(Ravg(1,:),Ravg(2,:))
   if I==1 then    
      xstring(-ech,ech,["Effet intgral; zr0="+string(z(1))+"    zv0"+string(z(2))]) ;
   end;   

endfunction;
//---------------------------------------------
function v=f(x,u)  //fonction d'volution
     v=[x(4)*cos(x(5))*cos(x(3));
        x(4)*cos(x(5))*sin(x(3));
        x(4)*sin(x(5))/3;
        u(1);u(2) ];
endfunction;
//---------------------------------------------
function theta1=arg(a,v)
  theta=atan(v(2),v(1));
  k=round((a-theta)/(2*%pi)); 
  theta1=theta+2*k*%pi;
endfunction  
//---------------------------------------------
function v=h(c,x)  
	r=sqrt(x(1)^2+x(2)^2);
  v=c(2)/r*[x(2);-x(1)]+vr/r*atan(rho*(c(1)-r))*[x(1);x(2)];
endfunction;
//---------------------------------------------


global r0 v0 sortie ech I x;
r0=50; v0=10; sortie=%F; ech=50;
I=0 //pas d'effet intgral
t=0;
rand('normal');

x=[-60;0;1*%pi;2;0];  //x=[x,y,theta,v,delta]
z=[0;0];L=3;u=[0;0];dt=0.013;
vr=15;rho=0.3;
seteventhandler('my_eventhandler');
while sortie==%F, 
        t=t+dt;
        c=[r0;v0];  //c=[r0,v0]
    				draw_voiture(x)
        w=[norm(h(c+0.2*z,x));arg(x(3),h(c+0.2*z,x))];
        wdot=[0;0];
        v=diag([2,3])*(w-[x(4);x(3)])+2*diag([0,3])*(wdot-[0;x(4)*sin(x(5))/L]);
        A=[1,0;sin(x(5))/L,x(4)*cos(x(5))/L];
        u=inv(A)*v;
        x=x+f(x,u)*dt;
        erreur=c-[sqrt(x(1)^2+x(2)^2);sign(c(2))*x(4)];
        if I==1 then  //effet intgral 
        	z=z+erreur*dt;
         else z=[0;0];
        end; 
end;
seteventhandler('') //suppress the event handler
xdel();
//---------------------------------------------
