//---------------------------------------------
function draw_voiture(x)
   M=[-1  4 5  5 4 -1 -1   -1 0  0  -1  1  0 0 -1 1 0 0 3 3 3;  //Chassis
      -2 -2 -1 1 2 2  -2   -2 -2 -3 -3 -3 -3 3  3 3 3 2 2 3 -3;
      ones(1:21)] ;
   Rav=[-1 1;0 0;1 1];  //Motif d'une roue avant
   R=[cos(x(3)),-sin(x(3)),x(1);sin(x(3)),cos(x(3)),x(2);0 0 1];
   M=R*M;    
   Ravd=R*[cos(x(5)),-sin(x(5)) 3;sin(x(5)),cos(x(5)) 3 ;0 0 1]*Rav;
   Ravg=R*[cos(x(5)),-sin(x(5)) 3;sin(x(5)),cos(x(5)) -3;0 0 1]*Rav;
   xbasc(); 
   xset('thickness',2);xsetech([0 0 1 1],1.1*[-10 -10 65 40]);  
   xpoly(M(1,:),M(2,:));
   xpoly(Ravd(1,:),Ravd(2,:))
   xpoly(Ravg(1,:),Ravg(2,:))
endfunction;
//---------------------------------------------
function v=f(x,u)  //fonction d'volution
     v=[x(4)*cos(x(5))*cos(x(3));
        x(4)*cos(x(5))*sin(x(3));
        x(4)*sin(x(5))/3;
        u(1);u(2) ];
endfunction;
//---------------------------------------------
function y=g(x)  //fonction d'volution
     y=[x(4);x(3)];
endfunction;
//---------------------------------------------
x=[35;35;0;-2;0.0];  //x=[x,y,theta,v,delta)
L=3;
u=[0;0];
dt=0.01;
for k=1:10000,
        draw_voiture(x);
        w=[-2;floor(k/1000)*%pi/4];  //hexagone
        //w=[-2-k/1000;k/200];  //spirale
        v=1*(diag([2,3])*(w-g(x))+2*diag([0,3])*[0;-x(4)*sin(x(5))/L]);
        A=[1, 0;sin(x(5))/L,x(4)*cos(x(5))/L];
        u=inv(A)*(v);
        x=x+f(x,u)*dt;
end;
//---------------------------------------------
