function my_eventhandler(win,x,y,ibut)   //(handler = baggagiste)
       global h10 h30 sortie;
       xinfo('h1: a,q; h3: p,l; Fin : F;');
       if ascii(ibut)=='a' then h10=h10+1; end   
       if ascii(ibut)=='q' then h10=h10-1; end   
       if ascii(ibut)=='p' then h30=h30+1; end   
       if ascii(ibut)=='l' then h30=h30-1; end   
       if ascii(ibut)=='F' then sortie=%T;    end   
endfunction

//---------------------------------------------

function drawbacs()
   xbasc();xsetech([0 0 1 1],[-1 -1 16 12]);
   xset("thickness",2)
   xset("color",0);
   a=0.1;
   xpoly([0-a 0-a ],[10 1+a])
   xpoly([-7 23],[0-a 0-a])
   xpoly([16+a 16+a],[1+a 10])
   xpoly([4+a   4+a  6-a  6-a],[10 1+a 1+a 10])
   xpoly([10+a 10+a 12-a 12-a],[10 1+a 1+a 10])
endfunction
//---------------------------------------------
function draw(x,u)
   //eau dans les bacs
   rouge=5;bleu=2;blanc=8;vert=3;noir=0;magenta=6;
   xset("pattern",2);
   xfpoly([0 0 -6 22 16 16 12 12 10 10 6 6 4 4],[x(1) 1 0 0 1 x(3) x(3) 1 1 x(2) x(2) 1 1 x(1)])
   //effacement 
   xset("pattern",blanc);
   xfpoly([ 0  0  4  4],[11 x(1) x(1) 11])
   xfpoly([ 6  6 10 10],[11 x(2) x(2) 11])
   xfpoly([12 12 16 16],[11 x(3) x(3) 11])
   //entre d'eau
   if (u(1)>=0) then xset('pattern',2); 
   		else xset('pattern',3); //en vert si u(1)<0
   end,
   xfpoly([ 1 1 1+0.1*u(1) 1+0.1*u(1)],[10 0.1 0.1 10])
   if (u(2)>=0) then xset('pattern',2);
   		else xset('pattern',3); //en vert si u(2)<0
   end,
   xfpoly([ 13 13 13+0.1*u(2) 13+0.1*u(2)],[10 0.1 0.1 10])
   xset("pattern",noir);
   xset('font',2,12);
   xstring(5,11,["h10="+string(h10)+"    h30="+string(h30)+"       "]) ;
endfunction;
//---------------------------------------------
function q=q(h)
    a=0.4;g=10;
    q=a*sign(h)*sqrt(2*g*abs(h))
endfunction
//---------------------------------------------
function v=f(x,u)  //fonction d'volution
    //u=u+[0;-1];    //cration d'une fuite
    v=[-q(x(1))-q(x(1)-x(2))+u(1);
        q(x(1)-x(2))-q(x(2)-x(3));
       -q(x(3))+q(x(2)-x(3))+u(2) ];
endfunction;
//---------------------------------------------
global h10 h30 sortie;
sortie=%F; h10=7; h30=3;
drawbacs();
x=[2;2;2];
k=[1 0;0 1];
z=[0;0];
dt=0.05;
t=0;
seteventhandler('my_eventhandler');
while sortie==%F, 
        w=[h10;h30];
        t=t+dt;
        y=[x(1);x(3)];
        z1=z+(w-y)*dt;   //2 intgrateurs
        v=0.5*z+(w-y);   //entre du systeme linaris par feedback
      	 u=-[-q(x(1))-q(x(1)-x(2));-q(x(3))+q(x(2)-x(3))]+v;
	      x1=x+f(x,u)*dt;
        draw(x,u);
        x=x1;
        z=z1;
end;
seteventhandler('') //suppress the event handler
xdel();









