function my_eventhandler(win,xs,ys,ibut)   //(handler = baggagiste)
       global V sortie ech u x;
       [xs,ys]=xchange(xs,ys,'i2f')
       xinfo('Rglage Vent : v,V; Rglage Zoom : z,Z; Fin : F;  '+ 'xs='+string(xs)+', ys='+string(ys)+', ibut='+string(ibut))
       if ascii(ibut)=='v' then V=V+10;       end   
       if ascii(ibut)=='V' then V=V-10;       end   
       if ascii(ibut)=='z' then ech=ech*0.95; end   
       if ascii(ibut)=='Z' then ech=ech/0.95; end   
       if ascii(ibut)=='F' then sortie=%T;    end 
       if ascii(ibut)=='w' then u(2)=-1;      end
       if ascii(ibut)=='x' then u(2)= 1;      end
       if ascii(ibut)=='p' then u(1)=-1;      end
       if ascii(ibut)=='l' then u(1)= 1;      end
       if ascii(ibut)=='A' then x=x0;         end
endfunction


function draw(x)  //x=(x,y,theta,deltav,deltag,v,w)
   rouge=5;bleu=2;blanc=8;vert=3;noir=0;magenta=6;
   theta=x(3);   deltav=x(4); deltag=x(5);
   coque=[-1  4 5  5 4 -1 -1 -1; -2 -2 -1 1 2 2  -2 -2 ; ones(1:8)] ;
   voile=[-5*L 0;0 0;1 1];  
   gouvernail=[-1 1;0 0;1 1];
   [fv,fg]=forces(x);
   Mfv=[-L -L;0 -fv/100;1 1];
   Mfg=[0 0;0 fg/100;1 1];
   R=[cos(theta),-sin(theta),x(1);sin(theta),cos(theta),x(2);0 0 1];
   coque=R*coque;    
   Rdeltav=[cos(deltav),-sin(deltav),3;sin(deltav),cos(deltav),0;0 0 1];
   Rdeltag=[cos(deltag),-sin(deltag),-1;sin(deltag),cos(deltag),0;0 0 1];
   voile=R*Rdeltav*voile;
   Mfv=R*Rdeltav*Mfv;
   gouvernail=R*Rdeltag*gouvernail;
   Mfg=R*Rdeltag*Mfg;
   xbasc();
   xset('thickness',2);
   isoview(-ech,ech,-ech,ech)
   xset('color',magenta);
   xset('color',noir);
   xset('font',2,12);
   xstring(-ech,ech,["Vent = "+string(V)+"m/s"]) ;
   xarrows([-ech+5,-ech+5],[ech,ech-V],2,bleu)
   xpoly(coque(1,:),coque(2,:))
   xset('color',5)
   xpoly(voile(1,:),voile(2,:))
   xpoly(gouvernail(1,:),gouvernail(2,:))
   xset('color',3)
   xset('thickness',1);
   xarrows(Mfv(1,:),Mfv(2,:),1,vert)
   xarrows(Mfg(1,:),Mfg(2,:),1,vert)
endfunction;
//---------------------------------------------
function [fv,fg]=forces(x)  //x=(x,y,theta,deltav,deltag,v,w)
     theta=x(3);deltav=x(4);deltag=x(5);vitesse=x(6);omega=x(7);
     fv=alphav*V*cos(theta+deltav)-alphav*vitesse*sin(deltav)
     fg=alphag*vitesse*sin(deltag);
endfunction;
//---------------------------------------------
function Dx=f(x,u)  //x=(x,y,theta,deltav,deltag,v,w)
     theta=x(3);deltav=x(4);deltag=x(5);vitesse=x(6);omega=x(7);
     [fv,fg]=forces(x);
     Dx=[vitesse*cos(theta);
        vitesse*sin(theta)-beta*V;
        omega;    
       	u(1);u(2);
       	(1/m)*( fv*sin(deltav)-fg*sin(deltag)-vitesse*alphaf);
        (1/J)*((L-rv*cos(deltav))*fv-rg*fg*cos(deltag)-alphatheta*omega);
       ];
endfunction;
//---------------------------------------------
global V sortie ech u x;
sortie=%F;
ech=60;
q=1;
L=1;											//	distance mat-centre de pousse de la voile
alphaf=60; 							  	//	frottement de l'eau
alphatheta=500;      //	frottement angulaire de l'eau
alphav=500; 	        //	portance de la voile
alphag=15*20; 	      //	portance du gouvernail
beta=0.05;           // drive du bateau
rv=1; 		             //	distance de G au mat
rg=2; 		             //	distance de G au gouvernail 
V=10;	               //	vent (m/sec)
m=1000;		            //	masse du bateau en kg
J=2000;		            //	moment d'inertie
x0=[0;0;0;0.5;0.0;2;0];   //x=(x,y,theta,deltav,deltag,v,w)
x=x0;
t=0;dt=0.01;
u=[0,0];
seteventhandler('my_eventhandler');
while sortie==%F, 
        pvm_set_timer();
        t=t+dt;
        x=x+f(x,u)*dt;
        u=[0,0];
        draw(x);
        dt=pvm_get_timer()/1000000;
end;
seteventhandler('') //suppress the event handler
xdel();

