function draw(x,couleur);
  	xbasc();isoview(-2,3,-1,2);xset('thickness',2);
  	xset('color',couleur);
		xpoly([ x(1), x(1)-l*sin(x(2))], [0, l*cos(x(2))]);
		xpoly([x(1)-.5,x(1)+.5,x(1)+.5,x(1)-.5,x(1)-.5], [0,0,-.25,-.25,0]);
endfunction
//------------------------------------------------------
function [Ar,Br,Cr,Dr]=RegulKLH(A,B,C,E,pcom,pobs);
		K=ppol(A,B,pcom);
		L=ppol(A',C',pobs)';
		H=-inv(E*inv(A-B*K)*B);
		Ar=A-B*K-L*C;		Br=[B*H L];
		Cr=-K;			Dr=[H,zeros(B'*C')]  
endfunction
//------------------------------------------------------
function v=f(x,u)
    v=[x(3);
       x(4);
      (m*sin(x(2))*(g*cos(x(2))-l*x(4)^2)+u)/(M+m*sin(x(2))^2);
     	(sin(x(2))*((M+m)*g-m*l*x(4)^2*cos(x(2)))+u*cos(x(2)))/(l*(M+m*sin(x(2))^2))];
endfunction;
//------------------------------------------------------
rand('normal');
m=1;M=5;l=1;g=9.81;
dt=0.005;
A=[0 0 1 0;0 0 0 1;0 m*g/M 0 0;0 (M+m)*g/(l*M) 0 0];		
B=[0;0;1/M;1/(l*M)];
C=[1 0 0 0];
E=[1 0 0 0];
[Ar,Br,Cr,Dr]=RegulKLH(A,B,C,E,[-2 -2 -2 -2],[-2 -2 -2 -2])
x=[0;0.02;0;0];		xr=[0;0;0;0];
for k=1:8000
  w=2*sign(sin(k*0.001));
  y=C*x+0.003*rand();
  u=Cr*xr+Dr*[w;y];
  xr=xr+(Ar*xr+Br*[w;y])*dt;
  //xr1=xr+(f(xr,u)-L*(C*xr-y))*dt;     //observateur tendu
  x=x+f(x,u)*dt;
  draw(xr,3); 
  draw(x,0);
end
  
