//---------------------------------------------
function draw_un_char(x,y,theta,delta,L,col)   // A ne pas toucher  
   M=[     0  -0.3  0.3  0 0 -0.3 0.3 0 0 L ;  
          -0.4 -0.4 -0.4 -0.4 0.4  0.4 0.4 0.4 0 0;
      ones(1:10)] ;
   Rav=[-0.4 0.4;0 0;1 1]; 
   R=[cos(theta),-sin(theta),x;sin(theta),cos(theta),y;0 0 1];
   M=R*M;    
   Rav=R*[cos(delta),-sin(delta), L;sin(delta),cos(delta) 0;0 0 1]*Rav;
   xset('color',col);
   xpoly(M(1,:),M(2,:));
   xpoly(Rav(1,:),Rav(2,:));
endfunction;
//---------------------------------------------
function draw_snake(x,u) // A ne pas toucher
   rouge=5;bleu=2;blanc=8;vert=3;noir=0;magenta=6;
   L1=1;L2=1; 
   theta=x(3);  delta=x(5);
   theta2=theta+delta;
   xbasc(); xset("pixmap",1);   ech=5;   xset('thickness',2);
   isoview(-ech,ech,-ech,ech);
   draw_un_char(x(1),x(2),theta,u(1),L1,rouge);
   draw_un_char(x(1)-L2*cos(theta2),x(2)-L2*sin(theta2),theta2,-delta,L2,bleu)
   xset("wshow");
endfunction

//---------------------------------------------
// Le programme principal commence ici
//---------------------------------------------

x=[0;0;0;0;0]; 
dt=0.01; 
t=0;
u=[1;0];  
for t=0:dt:10,
     t=t+dt;
     draw_snake(x,u);
     x=[t;0.2*t;t;0.1*t;0.1*t];  // ici, il faut faire bouger x par la mthod d'Euler
end;

