function my_eventhandler(win,x,y,a)   //(handler = baggagiste)
       global puls bias sortie ech;
      [xf,yf]=xchange(x,y,'i2f')
       xinfo('bias : w,x ; pulsation:p,l ; Amplitude:a,q ; Zoom : z,Z; Fin : F; ')
       if ascii(a)=='w' then bias=bias+0.02; end   
       if ascii(a)=='x' then bias=bias-0.02; end   
       if ascii(a)=='z' then ech=ech*0.95; end   
       if ascii(a)=='Z' then ech=ech/0.95; end   
       if ascii(a)=='F' then sortie=%T;    end  
       if ascii(a)=='l' then puls=puls*0.9; end   
       if ascii(a)=='p' then puls=puls/0.9; end
endfunction
//---------------------------------------------
function draw_une_voiture(x,y,theta,delta,L,col)
   M=[     0  -0.3  0.3  0 0 -0.3 0.3 0 0 L ;  //Chassis
          -0.4 -0.4 -0.4 -0.4 0.4  0.4 0.4 0.4 0 0;
      ones(1:10)] ;
   Rav=[-0.4 0.4;0 0;1 1];  //Motif d'une roue avant
   R=[cos(theta),-sin(theta),x;sin(theta),cos(theta),y;0 0 1];
   M=R*M;    
   Rav=R*[cos(delta),-sin(delta), L;sin(delta),cos(delta) 0;0 0 1]*Rav;
   xset('color',col);
   xpoly(M(1,:),M(2,:));
   xpoly(Rav(1,:),Rav(2,:));
endfunction;
//---------------------------------------------
function draw_snake(x,u)
   rouge=5;bleu=2;blanc=8;vert=3;noir=0;magenta=6;
   xbasc();xset('thickness',2);
   isoview(-ech,ech,-ech,ech);
   theta=x(3);
   delta=x(5);
   draw_une_voiture(x(1),x(2),theta,u(1),L1,rouge);
   theta2=theta+delta;
   draw_une_voiture(x(1)-L2*cos(theta2),x(2)-L2*sin(theta2),theta2,(-1)*delta2,L2,bleu)
endfunction
//---------------------------------------------
function Dx=f(x,u)  
   x1=x(1);
   y1=x(2);
   theta1=x(3);
   v=x(4);
   delta1=u(1);
   delta2=x(5);
   ddelta2=v*(((-1)*tan(delta1)/L1)-(sin(delta2)/L2));
     Dx=[v*cos(theta1);
         v*sin(theta1);
         v*(+1)*tan(delta1)/L1;
         u(2)*ddelta2-0.1*v1;
         ddelta2 ];
endfunction;
//---------------------------------------------
global puls bias sortie ech;
x=[-8;-8;1;1.1;0.4];
puls=5.0;
Sbias=0;
L2=1;L1=1;
ech=10;
dt=0.002;
u=[0;0];
sortie=%F;
t=0;
u1=0;
u2bar=1;
pbar=1;
U1=[];
u1moy=0;
U1moy=[];
T=[];
//---------------------------------------------
seteventhandler('my_eventhandler');
draw_snake(x);
while sortie==%F, 
        pvm_set_timer();
        draw_snake(x,u);
        delta2=x(5);     v1=x(4);
        ddelta2=v1*((-tan(u1)/L1)-(sin(delta2)/L2));
        eps=sign(cos(puls*t)-bias+0.1*sign(u1moy));
        u1=-atan(sin(delta2)+eps*pbar/(v1*u2bar));
        u1moy=(1-0.5*dt)*u1moy+(0.5*dt)*u1;
        U1moy=[U1moy;u1moy];
        u2=eps*u2bar;
        pouss=(v1*((-tan(u1)/L1)-(sin(delta2)/L2)))*u2;
        u=[u1;u2];
        x=x+f(x,u)*dt;  
        U1=[U1;u1];
        T=[T;t];
        dt=pvm_get_timer()/1000000;
        t=t+dt;
end;
seteventhandler('') //suppress the event handler
xdel();
tmin=round(0.7*size(T,1));
plot2d(T(tmin:$),U1(tmin:$));
//plot2d(T,U1moy);
