function my_eventhandler(win,x,y,a)   //(handler = baggagiste)
       global ampl puls bias sortie ech;
      [xf,yf]=xchange(x,y,'i2f')
       xinfo('bias : w,x ; pulsation:p,l ; Amplitude:a,q ; Zoom : z,Z; Fin : F; ')
       if ascii(a)=='w' then bias=bias+0.02; end   
       if ascii(a)=='x' then bias=bias-0.02; end   
       if ascii(a)=='z' then ech=ech*0.95; end   
       if ascii(a)=='Z' then ech=ech/0.95; end   
       if ascii(a)=='F' then sortie=%T;    end  
       if ascii(a)=='l' then puls=puls*0.9; end   
       if ascii(a)=='p' then puls=puls/0.9; end
       if ascii(a)=='q' then ampl=ampl*0.9; end   
       if ascii(a)=='a' then ampl=ampl/0.9; end
endfunction
//---------------------------------------------
function draw_une_voiture(x,y,theta,delta,L,col)
   M=[     0  -0.3  0.3  0 0 -0.3 0.3 0 0 L ;  //Chassis
          -0.4 -0.4 -0.4 -0.4 0.4  0.4 0.4 0.4 0 0;
      ones(1:10)] ;
   Rav=[-0.4 0.4;0 0;1 1];  //Motif d'une roue avant
   R=[cos(theta),-sin(theta),x;sin(theta),cos(theta),y;0 0 1];
   M=R*M;    
   Rav=R*[cos(delta),-sin(delta), L;sin(delta),cos(delta) 0;0 0 1]*Rav;
   xset('color',col);
   xpoly(M(1,:),M(2,:));
   xpoly(Rav(1,:),Rav(2,:));
endfunction;
//---------------------------------------------
function draw_snake(x,u)
   rouge=5;bleu=2;blanc=8;vert=3;noir=0;magenta=6;
   xbasc();xset('thickness',2);
   isoview(-ech,ech,-ech,ech);
   theta=x(3);
   delta=x(5);
   draw_une_voiture(x(1),x(2),theta,u(1),L1,rouge);
   theta2=theta+delta;
   draw_une_voiture(x(1)-L2*cos(theta2),x(2)-L2*sin(theta2),theta2,-delta,L2,bleu)
endfunction
//---------------------------------------------
function Dx=f(x,u)  
   x1=x(1);
   y1=x(2);
   theta1=x(3);
   v=x(4);
   delta1=u(1);
   delta2=x(5);
   ddelta2=v*((-tan(delta1)/L1)-(sin(delta2)/L2));
     Dx=[v*cos(theta1);
         v*sin(theta1);
         v*(+1)*tan(delta1)/L1;
         u(2)*ddelta2-0.1*v;
         ddelta2 ];
endfunction;
//---------------------------------------------
global puls ampl bias sortie ech;
x=[-8;-8;1;1.1;0.4];
puls=1.0;
ampl=0.2;
bias=0;
L2=1;L1=1;
ech=10;
dt=0.002;
u=[0;0];
sortie=%F;
t=0;
Pouss=[];
T=[];
//---------------------------------------------
seteventhandler('my_eventhandler');
draw_snake(x)
while sortie==%F, 
        pvm_set_timer();
        t=t+dt;
        draw_snake(x,u);
        x=x+f(x,u)*dt;  //methode d'Euler
        delta=x(5);    v=x(4);
        ddelta=v*((-tan(u(1))/L1)-(sin(delta)/L2));
        Pouss=[Pouss;ddelta*u(2)];
        T=[T;t];
        u=[ampl*cos(puls*t)+bias;3*sign(ddelta)];
        dt=pvm_get_timer()/1000000;
end;
seteventhandler('') //suppress the event handler
xdel();
xset("font size",24);
plot2d(T,Pouss);

