//-----------------------dessin du verin-------------------------
function draw(x,c)
   xset("pattern",c)
   V=[-15+x(1) -15+x(1) -15+x(1) 15+x(1);6 -6 0 0];
   tube= [-15 15 15 -15 -15;6 6 -6 -6 6];
   xpoly(tube(1,:),tube(2,:),"lines",0)
   xpoly(V(1,:),V(2,:),"lines",c)
   xfarc(14.5+x(1),2,2,4,0,360*64)
endfunction;
//--------------------la fonction d'volution---------------------
function xdot=f(x,u)
	k=1;a=1;m=1;  
         xdot=[x(2); (a*x(3)-k*x(1))/m; -x(3)*(x(2)-u/a)/x(1)];
endfunction;
//------------------------------------------------------------------
wrect=[0 0 1 1];
frect=[-20 -30 40 30];
xsetech(wrect,frect);
x=[7; 0.5; 6];   //(z,zdot,p)
dt=0.02;   
xbar=[4.8;0;4.8];
A=[0 1 0;-1 0 1;0 -1 0];
B=[0;0;1]; C=[1 0 0];
K=ppol(A,B,[-2,-2,-2]);
L=(ppol(A',C',[-2,-2,-2]))';
E=[1 0 0];
H=(-E*((A-B*K)^(-1))*B)^(-1);
Ar=A-B*K-L*C;
Cr=-K;
Dr=H;
xr=[0;0;0];
wbar=E*xbar;
Br=[B*H L*C];
for k=1:3000
        w=10*(sin(0.01*k)+1);
        u=Cr*xr+Dr*[w-wbar];
	x1r=xr+(Ar*xr+Br*[w-wbar;x-xbar])*dt;
        x1=x+f(x,u)*dt;
        draw(x,8);
	draw(x1,0); 	
        x=x1;
        xr=x1r;
end;


